# -*- coding: UTF-8 -*-
# Copyright (c) 2003-2004  Jens Carroll Inventronik GmbH
#
#   This is a graphical front-end for xwisp
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2, or (at your option)
#   any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
from wxPython.wx import *
from wxPython.lib.buttons import *
import os, time, images, time, xwisp, webbrowser

# version, copyright header
__version__ = "1.2"
__date__    = "Juli, 2003"
__author__  = "Inventronik GmbH, Jens Carroll"

#language = {'ProgButton' }
de = {'statusbar':'Serielle Schnittstelle: %s, Sprache: %s',
      'serialline':'Serielle Schnittstelle',
      'german':'Deutsch',
      'english':'Englisch',
      'language':'Sprache',
      'quit':'Beenden',
      'properties':'Einstellungen',
      'about':'Ueber ...',
      'help':'Hilfe',
      'picprogramming':'PIC programmieren',
      'openhex':' HEX-Datei oeffnen ...',
      'executepic':'Programm danach ausfuehren',
      'protectionfuse':'Leseschutz aktivieren',
      'progprevfile':'zuvor geoeffnete HEX-Datei prog.',
      'picreading':'PIC-Programm auslesen',
      'savehex':' HEX-Datei speichern ...',
      'picprogram':'PIC-Programm ...',
      'erase':' loeschen',
      'execute':' ausfuehren',
      'hexfiles':'PIC HEX-Dateien',
      'allfiles':'Alle Dateien',
      'chosefile':'Datei auswaehlen',
      'porterror':'Fehler: Port konnte nicht geoeffnet werden!',
      'copyrightinv':'Grafisches Frontend (c) 2003-2004 Inventronik GmbH',
      'copyrightwisp':'XWisp (c) 2002 Wouter van Ooijen / voti',
      'restart':'Damit die Sprachumstellung wirksam wird,   \r\n muessen Sie das Programm neustarten.',
      }
      
en = {'statusbar':'Serial line: %s, Language: %s',
      'serialline':'Serial line',
      'german':'german',
      'english':'english',
      'language':'Language',
      'quit':'Quit',
      'properties':'Properties',
      'about':'About ...',
      'help':'Help',
      'picprogramming':'PIC programing',
      'openhex':' Open HEX-file ...',
      'executepic':'Execute program afterwards',
      'protectionfuse':'Burn protection fuse',
      'progprevfile':'Burn previously opened HEX-file',
      'picreading':'Read out PIC program',
      'savehex':' Save HEX-file ...',
      'picprogram':'PIC-Target ...',
      'erase':' Erase',
      'execute':' Execute',
      'hexfiles':'PIC HEX-files',
      'allfiles':'All Files',
      'chosefile':'Choose file',
      'porterror':'Error: Port open failed',
      'copyrightinv':'Graphical front-end (c) 2003-2004 Inventronik GmbH',
      'copyrightwisp':'XWisp (c) 2002 Wouter van Ooijen / voti',
      'restart':'Please restart the program to change the used language.',
      }


# global variables
SerUsbPort = 'COM4' # COM1, COM2, ..., ttyS0, ttyS1, ..., /dev/ttyUSB0, etc
SerUsbCheck = 3 # check mark index for the menu
UsbDev = '/dev/ttyUSB%d' # to create a usb device name

if wxPlatform == '__WXMSW__':
    TtyDev = 'COM%d' # to create serial line name (Windows)
    WinCom = 1 # COM/ttyS correction factor
else:
    TtyDev = '/dev/ttyS%d' # to create a tty device name (Linux)
    WinCom = 0 # COM/ttyS correction factor

Language = 'en' # currently available de, en
PrevWriteFile = '' # store filename from previous write action
LangDict = en;

class AboutBox(wxDialog):
    def __init__(self, parent):
        global LangDict
        if wxPlatform == '__WXGTK__':
            wxDialog.__init__(self, parent, -1, LangDict['about'], wxDefaultPosition, wxSize(355, 180))
        elif wxPlatform == '__WXMSW__':
            wxDialog.__init__(self, parent, -1, LangDict['about'], wxDefaultPosition, wxSize(285, 180))
        
        bmp = images.getInventronikLogoBitmap()
        wxStaticBitmap(self, -1, bmp, wxPoint(10, 10),
                       wxSize(bmp.GetWidth(), bmp.GetHeight()))

        wxStaticText(self, -1, LangDict['copyrightwisp'], wxPoint(10, 60))
        wxStaticText(self, -1, LangDict['copyrightinv'], wxPoint(10, 75))
        
        self.button = wxButton(self, 2001, "OK", wxPoint(70, 115), wxSize(50, -1))
        EVT_BUTTON(self, 2001, self.OnOK)
            
        b = wx.Button(self, 2002, "Mehr Infos?", wxPoint(130, 115), wxSize(80, -1))
        self.Bind(wx.EVT_BUTTON, self.OnInventronik, b)
        b.SetToolTipString("bei www.inventronik.de")
        
    def OnOK(self, event):
        self.Close()
        
    def OnInventronik(self, event):
        try:
            webbrowser.open('http://www.inventronik.de/index.php?id=17')
        except:
            pass
        self.Close()

class MyFrame(wxFrame):
    def __init__(self, parent, id):
        if wxPlatform == '__WXGTK__':
            wxFrame.__init__(self, parent, id, ' wxXWISP', size=(260, 420), style=(wx.DEFAULT_DIALOG_STYLE | wxMINIMIZE_BOX))
        elif wxPlatform == '__WXMSW__':
            wxFrame.__init__(self, parent, id, ' wxXWISP', size=(240, 400), style=(wx.DEFAULT_DIALOG_STYLE | wxMINIMIZE_BOX))
        self.CenterOnScreen()

        # read initial settings and set used language accordingly
        global SerUsbPort, Language, LangDict
        self.ReadInitalSetting()
        if Language=='de':
            LangDict=de
        else:
            LangDict=en

        # creatw a statusbar to show programming info
        self.CreateStatusBar()
        self.SetStatusText(LangDict['statusbar'] % (SerUsbPort, Language))

        # create a menu (COM1 .. COM8), language, etc.
        # Prepare the menu bar
        menubar = wxMenuBar()
 
        menu1 = wxMenu()
        submenu1 = wxMenu()
        
        if wxPlatform == '__WXGTK__':
            for i in range(0, 8):
                submenu1.Append(1011+i, ("ttyS%d" % i), ("ttyS%d" % i), wxITEM_RADIO)
            submenu1.AppendSeparator()
            for i in range(0, 6):
                submenu1.Append(1019+i, ("ttyUSB%d" % i), ("ttyUSB%d" % i), wxITEM_RADIO)
        elif wxPlatform == '__WXMSW__':
            for i in range(1, 9):
                submenu1.Append(1010+i, ("COM%d" % i), ("COM%d" % i), wxITEM_RADIO)
        menu1.AppendMenu(101, LangDict['serialline'], submenu1)

        submenu2 = wxMenu()
        submenu2.Append(1031, LangDict['german'], LangDict['german'], wxITEM_RADIO)
        submenu2.Append(1032, LangDict['english'], LangDict['english'],  wxITEM_RADIO)
        menu1.AppendMenu(102, LangDict['language'], submenu2)

        menu1.AppendSeparator()
        menu1.Append(103, LangDict['quit'])
        menubar.Append(menu1, LangDict['properties'])
        
        menu2 = wxMenu()
        menu2.Append(1090, LangDict['about'])
        menubar.Append(menu2, LangDict['help'])
        self.SetMenuBar(menubar)
        
        self.SetMenuBar(menubar)
        submenu1.Check(1011+SerUsbCheck, true)
        submenu2.Check(1031+bool(Language=="en"), true)

        EVT_MENU(self, 1011, self.MenuCOM1)
        EVT_MENU(self, 1012, self.MenuCOM2)
        EVT_MENU(self, 1013, self.MenuCOM3)
        EVT_MENU(self, 1014, self.MenuCOM4)
        EVT_MENU(self, 1015, self.MenuCOM5)
        EVT_MENU(self, 1016, self.MenuCOM6)
        EVT_MENU(self, 1017, self.MenuCOM7)
        EVT_MENU(self, 1018, self.MenuCOM8)
        EVT_MENU(self, 1019, self.MenuUSB0)
        EVT_MENU(self, 1020, self.MenuUSB1)
        EVT_MENU(self, 1021, self.MenuUSB2)
        EVT_MENU(self, 1022, self.MenuUSB3)
        EVT_MENU(self, 1023, self.MenuUSB4)
        EVT_MENU(self, 1024, self.MenuUSB5)
        EVT_MENU(self, 103,  self.OnCloseWindow)
        EVT_MENU(self, 1031, self.MenuLangDE)
        EVT_MENU(self, 1032, self.MenuLangEN)
        EVT_MENU(self, 1090, self.OnHelpAbout)

        panel = wxPanel(self, -1)
        self.PrevWriteFile = None
 
        # Layout controls on panel:
        vs = wxBoxSizer(wxVERTICAL)

        # create a static box
        boxtitle = wxStaticBox(panel, -1, LangDict['picprogramming'], wxPoint(20, 20))
        box = wxStaticBoxSizer(boxtitle, wxVERTICAL)
        sizer = wxBoxSizer(wxVERTICAL)
        
        # Use a bitmap button (PIC programming)
        self.buttonProgPIC = wxGenBitmapTextButton(panel, -1, None, LangDict['openhex'], size = (200, 45))
        EVT_BUTTON(panel, self.buttonProgPIC.GetId(), self.OnClickWrite)
        bmp = images.getWriteChipBitmap()
        mask = wxMask(bmp, wxBLUE)
        bmp.SetMask(mask)
        self.buttonProgPIC.SetBitmapLabel(bmp)
        self.buttonProgPIC.SetBitmapSelected(bmp)
        self.buttonProgPIC.SetUseFocusIndicator(False)
        self.buttonProgPIC.SetBestSize()
        sizer.Add(self.buttonProgPIC, 0, wxALL | wxLEFT | wxEXPAND, 5)
        
        # Add some checkboxes for various adjustments
        self.checkboxExecute = wxCheckBox(panel, -1, LangDict['executepic'])
        sizer.Add(self.checkboxExecute, 0, wxALL | wxLEFT, 5)
        
        self.checkboxPrevFile = wxCheckBox(panel, -1, LangDict['progprevfile'])
        self.checkboxPrevFile.Enable(false);
        sizer.Add(self.checkboxPrevFile, 0, wxALL | wxLEFT, 5)
        EVT_CHECKBOX(panel, self.checkboxPrevFile.GetId(), self.OnPrevOpenedHEXFile)
        
        box.Add(sizer, 0, wxALIGN_CENTRE | wxALL, 5)
        vs.Add(box, 0, wxALL | wxEXPAND, 5)

        # create a static box
        boxtitle = wxStaticBox(panel, -1, LangDict['picreading'], wxPoint(20, 20))
        box = wxStaticBoxSizer(boxtitle, wxVERTICAL)
        
        # Use a bitmap button (reading a pic)
        button = wxGenBitmapTextButton(panel, -1, None, LangDict['savehex'], size = (200, 45))
        EVT_BUTTON(panel, button.GetId(), self.OnClickRead)
        bmp = images.getReadChipBitmap()
        mask = wxMask(bmp, wxBLUE)
        bmp.SetMask(mask)
        button.SetBitmapLabel(bmp)
        button.SetBitmapSelected(bmp)
        button.SetUseFocusIndicator(False)
        button.SetBestSize()

        sizer = wxBoxSizer(wxVERTICAL)
        sizer.Add(button, 0, wxALL | wxLEFT | wxEXPAND, 5)
        box.Add(sizer, 0, wxALIGN_CENTRE | wxALL, 5)
        vs.Add(box, 0, wxALL | wxEXPAND, 5)
        
        # create a static box
        boxtitle = wxStaticBox(panel, -1, LangDict['picprogram'], wxPoint(20, 20))
        box = wxStaticBoxSizer(boxtitle, wxVERTICAL)

        # a horizontal sizer holds the 2 following buttons
        sizer = wxBoxSizer(wxHORIZONTAL)
        
        # Use a bitmap button (deleting a pic)
        button = wxGenBitmapTextButton(panel, -1, None, LangDict['erase'], size = (200, 45))
        EVT_BUTTON(panel, button.GetId(), self.OnClickDelete)
        bmp = images.getDeleteChipBitmap()
        mask = wxMask(bmp, wxBLUE)
        bmp.SetMask(mask)
        button.SetBitmapLabel(bmp)
        button.SetBitmapSelected(bmp)
        button.SetUseFocusIndicator(False)
        button.SetBestSize()
        sizer.Add(button, 0, wxALL | wxLEFT | wxEXPAND, 5)
        
        # Use a bitmap button (executing a pic)
        button = wxGenBitmapTextButton(panel, -1, None, LangDict['execute'], size = (200, 45))
        EVT_BUTTON(panel, button.GetId(), self.OnClickExecute)
        bmp = images.getResetChipBitmap()
        mask = wxMask(bmp, wxBLUE)
        bmp.SetMask(mask)
        button.SetBitmapLabel(bmp)
        button.SetBitmapSelected(bmp)
        button.SetUseFocusIndicator(False)
        button.SetBestSize()
        sizer.Add(button, 0, wxALL | wxLEFT | wxEXPAND, 5)
        
        box.Add(sizer, 0, wxALIGN_CENTRE | wxALL, 5)
        vs.Add(box, 0, wxALL | wxEXPAND, 5)

        panel.SetSizer(vs)
        vs.Fit(panel)
        panel.Move((10,10))
        self.panel = panel

        EVT_CLOSE(self, self.OnCloseWindow)

    def OnHelpAbout(self, event):
        about = AboutBox(self)
        about.ShowModal()

    def MenuCOM1(self, event):
        global SerUsbPort, TtyDev, SerUsbCheck
        SerUsbPort = (TtyDev % (0+WinCom))
        SerUsbCheck = 0
        self.SetStatusText(LangDict['statusbar'] % (SerUsbPort, Language))

    def MenuCOM2(self, event):
        global SerUsbPort, TtyDev, SerUsbCheck
        SerUsbPort = (TtyDev % (1+WinCom))
        SerUsbCheck = 1 
        self.SetStatusText(LangDict['statusbar'] % (SerUsbPort, Language))

    def MenuCOM3(self, event):
        global SerUsbPort, TtyDev, SerUsbCheck
        SerUsbPort = (TtyDev % (2+WinCom))
        SerUsbCheck = 2
        self.SetStatusText(LangDict['statusbar'] % (SerUsbPort, Language))

    def MenuCOM4(self, event):
        global SerUsbPort, TtyDev, SerUsbCheck
        SerUsbPort = (TtyDev % (3+WinCom))
        SerUsbCheck = 3
        self.SetStatusText(LangDict['statusbar'] % (SerUsbPort, Language))

    def MenuCOM5(self, event):
        global SerUsbPort, TtyDev, SerUsbCheck
        SerUsbPort = (TtyDev % (4+WinCom))
        SerUsbCheck = 4
        self.SetStatusText(LangDict['statusbar'] % (SerUsbPort, Language))

    def MenuCOM6(self, event):
        global SerUsbPort, TtyDev, SerUsbCheck
        SerUsbPort = (TtyDev % (5+WinCom))
        SerUsbCheck = 5
        self.SetStatusText(LangDict['statusbar'] % (SerUsbPort, Language))

    def MenuCOM7(self, event):
        global SerUsbPort, TtyDev, SerUsbCheck
        SerUsbPort = (TtyDev % (6+WinCom))
        SerUsbCheck = 6
        self.SetStatusText(LangDict['statusbar'] % (SerUsbPort, Language))

    def MenuCOM8(self, event):
        global SerUsbPort, TtyDev, SerUsbCheck
        SerUsbPort = (TtyDev % (7+WinCom))
        SerUsbCheck = 7
        self.SetStatusText(LangDict['statusbar'] % (SerUsbPort, Language))

    def MenuUSB0(self, event):
        global SerUsbPort, UsbDev, SerUsbCheck
        SerUsbPort = (UsbDev % 0)
        SerUsbCheck = 8

    def MenuUSB1(self, event):
        global SerUsbPort, UsbDev, SerUsbCheck
        SerUsbPort = (UsbDev % 1)
        SerUsbCheck = 9

    def MenuUSB2(self, event):
        global SerUsbPort, UsbDev, SerUsbCheck
        SerUsbPort = (UsbDev % 2)
        SerUsbCheck = 10

    def MenuUSB3(self, event):
        global SerUsbPort, UsbDev, SerUsbCheck
        SerUsbPort = (UsbDev % 3)
        SerUsbCheck = 11

    def MenuUSB4(self, event):
        global SerUsbPort, UsbDev, SerUsbCheck
        SerUsbPort = (UsbDev % 3)
        SerUsbCheck = 12

    def MenuUSB5(self, event):
        global SerUsbPort, UsbDev, SerUsbCheck
        SerUsbPort = (UsbDev % 3)
        SerUsbCheck = 13

    def MenuLangEN(self, event):
        global Language
        Language = 'en'
        dlg = wxMessageDialog(self, LangDict['restart'],
            'Info', wxOK | wxICON_INFORMATION)
        dlg.ShowModal()
        dlg.Destroy()

    def MenuLangDE(self, event):
        global Language
        Language = 'de'
        dlg = wxMessageDialog(self, LangDict['restart'],
            'Info', wxOK | wxICON_INFORMATION)
        dlg.ShowModal()
        dlg.Destroy()

    def OnClickDelete(self, event):
        "Delete target program"
        global app
        try:
            xwisp.Set_App(app)
            parm = ['PORT', SerUsbPort, 'ERASE']
            xwisp.XWisp_Main(parm)
        except:
            self.SetStatusText(LangDict['porterror'])

    def OnClickExecute(self, event):
        "Execute target program"
        global app
        xwisp.Set_App(app)
        try:
            parm = ['PORT', SerUsbPort, 'RUN']
            xwisp.XWisp_Main(parm)
        except:
            self.SetStatusText(LangDict['porterror'])
    
    def OnPrevOpenedHEXFile(self, event):
        global PrevWriteFile;
        if self.checkboxPrevFile.IsChecked():
            basename = os.path.basename(PrevWriteFile)
            print basename
            self.buttonProgPIC.SetLabel(" %s" % basename)
        else:
            self.buttonProgPIC.SetLabel(LangDict['savehex'])
        self.buttonProgPIC.Enable(false) # wxPython bug: the wxGenBitmapTextButton doens't get a redraw event
        self.buttonProgPIC.Enable(true)  # this will do the trick
        
    def OnClickWrite(self, event):
        "Erase and program target"
        global app, PrevWriteFile
        xwisp.Set_App(app)
        
        if self.checkboxPrevFile.IsChecked():
            try:
                wait = wxBusyCursor()
                self.Enable(false)
                add = []
                parm = ['PORT', SerUsbPort, 'ERASE']
                xwisp.XWisp_Main(parm)
                time.sleep(0.5); # just give the pic programmer a little time
                if self.checkboxExecute.IsChecked():
                    add += ['RUN']
                parm = ['PORT', SerUsbPort, 'WRITE', PrevWriteFile] + add
                xwisp.XWisp_Main(parm)
            except:
                self.SetStatusText(LangDict['porterror'])
            wait = None
            self.Enable(true)
        else:
            wildcard = ("%s (*.hex)|*.hex|" \
                "%s (*.*)|*.*" % (LangDict['hexfiles'], LangDict['allfiles']))

            dlg = wxFileDialog(self, LangDict['chosefile'], "", "", wildcard, wxOPEN)
            file = None
            if dlg.ShowModal() == wxID_OK:
                file = dlg.GetPaths()
            dlg.Destroy()
        
            if file<>None:
                try:
                    wait = wxBusyCursor()
                    self.Enable(false)
                    add = []
                    if self.checkboxExecute.IsChecked():
                        add += ['RUN']
                    parm = ['PORT', SerUsbPort, 'ERASE']
                    xwisp.XWisp_Main(parm)
                    time.sleep(0.5); # just give the pic programmer a little time
                    parm = ['PORT', SerUsbPort, 'WRITE', file[0]] + add
                    xwisp.XWisp_Main(parm)
                    PrevWriteFile = file[0]
                    self.checkboxPrevFile.Enable(true)
                except:
                    self.SetStatusText(LangDict['porterror'])
                    
                wait = None
                self.Enable(true)
            
    def OnClickRead(self, event):
        "Select a hex-file and redirect read request to xwisp"
        global SerUsbPort, app
        xwisp.Set_App(app)

        wildcard = "PIC HEX-Dateien (*.hex)|*.hex|" \
           "All files (*.*)|*.*"

        dlg = wxFileDialog(self, LangDict['chosefile'], "", "", wildcard, wxOPEN)
        file = None
        if dlg.ShowModal() == wxID_OK:
            file = dlg.GetPaths()
        dlg.Destroy()

        if file<>None:
            try:
                wait = wxBusyCursor()
                self.Enable(false)
                parm = ['PORT', SerUsbPort, 'READ', file[0]]
                xwisp.XWisp_Main(parm)
            except:
                self.SetStatusText(LangDict['porterror'])
            wait = None
            self.Enable(true)
        
    def OnCloseWindow(self, event):
        self.WriteInitialSetting()
        self.Destroy()

    def ReadInitalSetting(self):
        "Read settings stored in a simple text file"
        global SerUsbPort, SerUsbCheck, Language
        try:
            f = open("wxxwisp.ini")
            for line in f.readlines():
                if line[0:4]=="com=":
                    SerUsbPort = line[4:-2]
                elif line[0:5]=="lang=":
                    Language = line[5:-2]    
            f.close()
#            print "'%s'" % SerUsbPort[11:]
            if SerUsbPort[0:3]=="COM":
                SerUsbCheck = int(SerUsbPort[3:])-1
            if SerUsbPort[0:9]=="/dev/ttyS":
                SerUsbCheck = int(SerUsbPort[9:])
            if SerUsbPort[0:11]=="/dev/ttyUSB":
                SerUsbCheck = int(SerUsbPort[11:])+8
        except:
            pass
        
    def WriteInitialSetting(self):
        "Write settings to a simple text file"
        global SerUsbPort, Language
        f = open("wxxwisp.ini", "w")
        f.write("com=%s\r\n" % SerUsbPort)
        f.write("lang=%s\r\n" % Language)
        f.close()

    def UpdateStatusbar(self, infostr):
        "This function will be called from xwisp to update our statusbar"
        self.SetStatusText(infostr)
        if infostr[0:7]=="target:":
            self.SetTitle(infostr)

app = wxPySimpleApp()
win = MyFrame(None, -1)
win.Show(1)
app.win = win
app.MainLoop()

